#pragma config(Motor,  port1,           clawM,         tmotorVex393_HBridge, openLoop)
#pragma config(Motor,  port2,           rfDM,          tmotorVex393_MC29, openLoop, driveRight)
#pragma config(Motor,  port3,           lbDM,          tmotorVex393_MC29, openLoop, driveLeft)
#pragma config(Motor,  port4,           rtLM,          tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port5,           llLM,          tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port6,           ltLM,          tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port7,           rlLM,          tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port8,           lfDM,          tmotorVex393_MC29, openLoop, driveLeft)
#pragma config(Motor,  port9,           rbDM,          tmotorVex393_MC29, openLoop, driveRight)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

// This file is part of Vex-920-2017, and is therefore licensed under the GNU GPLv3 public license.
// Copyright (C) 2016  Ganden Schaffner

/* Power Expander Configuration
	A: rtLM
	B: llLM
	C: rfDM
	D: lbDM
*/

/* Controls
	LJoystick: Arcade movement
	LJoystick + RJoystick: Tank movement
	Btn5U/D: Open/close claw
	Btn6U/D: Raise/lower lift
	Btn8U: Toggle movement control style
*/

// This code is for the VEX cortex platform
#pragma platform(VEX2)

// Select Download method as "competition"
#pragma competitionControl(Competition)

//Main competition background code...do not modify!
#include "Vex_Competition_Includes.c"

// Global Variables
bool isTank = false; // 1 for arcade

// Methods

/*! General Methods
	Toggles between tank and arcade movement controls.
*/
void toggleMoveControls() {
	isTank = !isTank;
}

/*! General Methods: User Control
	Applies a deadband of 25 to the provided float.
	\param channel the input channel to apply the deadband to.
*/
float deadband(float input) {
	return (abs(input) < 25) ? 0 : input;
}

/*! User Control
	Moves the bot based on arcade controls (left stick).
*/
void usrMoveArcade() {
	motor[rfDM] = deadband(vexRT[Ch3]) - deadband(vexRT[Ch4]) * 0.5;
	motor[rbDM] = deadband(vexRT[Ch3]) - deadband(vexRT[Ch4]) * 0.5;
	motor[lfDM] = deadband(vexRT[Ch3]) + deadband(vexRT[Ch4]) * 0.5;
	motor[lbDM] = deadband(vexRT[Ch3]) + deadband(vexRT[Ch4]) * 0.5;
}

/*! User Control
	Moves the bot based on tank controls (left and right stick).
*/
void usrMoveTank() {
	motor[rfDM] = deadband(vexRT[Ch2]);
	motor[rbDM] = deadband(vexRT[Ch2]);
	motor[lfDM] = deadband(vexRT[Ch3]);
	motor[lbDM] = deadband(vexRT[Ch3]);
}

/*! User Control
	Raises/lowers the lift based on Btn6U/D.
*/
void usrLift() {
	int direction = vexRT[Btn6U] ? 1 : vexRT[Btn6D] ? -1 : 0;
	motor[rtLM] = 127 * direction;
	motor[rlLM] = 127 * direction;
	motor[ltLM] = 127 * direction;
	motor[llLM] = 127 * direction;
}

/*! User Control
	Opens/closes the claw based on Btn5U/D.
*/
void usrClaw() {
	int direction = vexRT[Btn5U] ? 1 : vexRT[Btn5D] ? -1 : 0;
	motor[clawM] = 127 * direction;
}

void pre_auton() {
	// Set bStopTasksBetweenModes to false if you want to keep user created tasks
	// running between Autonomous and Driver controlled modes. You will need to
	// manage all user created tasks if set to false.
	bStopTasksBetweenModes = true;

	// Set bDisplayCompetitionStatusOnLcd to false if you don't want the LCD
	// used by the competition include file, for example, you might want
	// to display your team name on the LCD in this function.
	bDisplayCompetitionStatusOnLcd = false;

	// All activities that occur before the competition starts
	// Example: clearing encoders, setting servo positions, ...
}

task autonomous() {
	AutonomousCodePlaceholderForTesting();
}

task usercontrol() {
	while (true) {
		if(isTank) {
			usrMoveTank();
		} else {
			usrMoveArcade();
		}
		if(vexRT[Btn8U]) {
			toggleMoveControls();
		}
		usrLift();
		usrClaw();
		wait1Msec(20);
	}
}
